// accel_ball_01
// Accelerometer-controlled ball.
// bjoern@stanford.edu 2/12/08, revised 12/15/08
// this file is included by accel_ball_01.fla

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.events.Event;

var xpin:Number=0;
var ypin:Number=1;
var arduino:Arduino = new Arduino("127.0.0.1", 11100);
var xacc:Number=0;
var yacc:Number=0;
var xpos:Number=0;
var ypos:Number=0;
var xvel:Number=0;
var yvel:Number=0;

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setAnalogPinReporting(xpin, Arduino.ON);
	arduino.setAnalogPinReporting(ypin, Arduino.ON);
	trace("Arduino initialized.");
}


function onEnterFrame(e:Event):void {
 // Update the position of the shape
  xacc = (512-arduino.getAnalogData(xpin))/256.0;  
  yacc = (512-arduino.getAnalogData(ypin))/256.0;  
  xvel = xvel + xacc;
  yvel = yvel + yacc;
  xpos = xpos + xvel + 0.5*xacc;
  ypos = ypos + yvel + 0.5*yacc;
  
  if(xpos<0 || xpos>stage.stageWidth-ball.width) {
    xvel=0;
  }
  if(ypos<0 || ypos>stage.stageHeight-ball.height) {
    yvel=0;
  }
  xpos = Math.max(0,Math.min(xpos,stage.stageWidth-ball.width));
  ypos = Math.max(0,Math.min(ypos,stage.stageHeight-ball.height));


  ball.x=xpos;
  ball.y=ypos;
  xlabel.text = (Math.round(xacc*100)/100).toString();
  ylabel.text = (Math.round(yacc*100)/100).toString();
}
arduino.setAnalogPinReporting(xpin, Arduino.ON);
arduino.setAnalogPinReporting(ypin, Arduino.ON);
addEventListener(Event.ENTER_FRAME, onEnterFrame);
trace(stage.stageHeight);
trace(stage.stageWidth);
