// ir_ranger_01
// threshold analog sensor data
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;

var inputPin:Number = 0; //which analog input pin?
var arduino:Arduino = new Arduino("127.0.0.1", 11100);

const IDLE:Number=0;
const ALARM:Number=1;
var mode:Number=IDLE;
var threshold:Number=512;
txtThreshold.text = threshold.toString(); //show threshold on screen


// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setAnalogPinReporting(inputPin, Arduino.ON);
	arduino.addEventListener(ArduinoEvent.ANALOG_DATA, onReceiveAnalogData);
	trace("Arduino initialized.");
}

function onReceiveAnalogData(e:ArduinoEvent):void {
	if(e.pin==inputPin) {
		txtValue.text = e.value.toString(); //show vlaue on screen
		switch(mode){
		case IDLE:
    		if (e.value>threshold) {
      			mode = ALARM;
				circle.visible=true;
    		}
    		break;
	 	case ALARM:
			if(e.value<threshold) {
		       mode=IDLE;
			   circle.visible=false;
		     }
		}
	}
}

circle.visible=false;


