// led_control_01
// turn LED connected to pin2 on Arduino on when mouse is pressed,
// off when mouse is released
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.events.MouseEvent;

var ledPin:Number = 2;

var arduino:Arduino = new Arduino("127.0.0.1", 11100);

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setPinMode(ledPin, Arduino.OUTPUT);
	arduino.writeDigitalPin(ledPin, Arduino.HIGH);
	trace("Arduino initialized.");
}

function onMouseClickEvent(event:MouseEvent):void {
	if(event.buttonDown) {
		arduino.writeDigitalPin(ledPin, Arduino.LOW);
	}else {
		arduino.writeDigitalPin(ledPin, Arduino.HIGH);
	}
}


stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseClickEvent);  
stage.addEventListener(MouseEvent.MOUSE_UP, onMouseClickEvent);  
