// led_control_04
// toggle LED connected to pin2 between on and blinking
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.events.MouseEvent;
import flash.events.Event;

var ledPin:Number =  2;
var arduino:Arduino = new Arduino("127.0.0.1", 11100);
var ON:int = 1;
var BLINK:int = 0;
var ledState:int = ON;
var frames:Number=0;

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setPinMode(ledPin, Arduino.OUTPUT);
	arduino.writeDigitalPin(ledPin, Arduino.LOW);
	trace("Arduino initialized.");
}

function onEnterFrame(event:Event):void {
	frames++;
	if (ledState==ON) {
		arduino.writeDigitalPin(ledPin, Arduino.LOW);
	} else {
		if(frames%2==0) {
			arduino.writeDigitalPin(ledPin, Arduino.LOW);
		} else {
			arduino.writeDigitalPin(ledPin, Arduino.HIGH);
		}
	}
}

function onMouseClickEvent(event:MouseEvent):void {
	if(ledState==ON) {
		ledState=BLINK;
	}else {
		ledState=ON;
	}
}

stage.addEventListener(MouseEvent.CLICK, onMouseClickEvent);  
addEventListener(Event.ENTER_FRAME, onEnterFrame);
