// led_control_05
// fading an LED connected to pin 9
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.events.MouseEvent;
import flash.events.Event;

var ledPin:Number = 9;
var arduino:Arduino = new Arduino("127.0.0.1", 11100);
var pwmValue:Number=0;
var rising:Boolean=true;
var step:Number=10;

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setPinMode(ledPin, Arduino.PWM);
	addEventListener(Event.ENTER_FRAME, onEnterFrame);
	trace("Arduino initialized.");
}

function onEnterFrame(event:Event):void {
	if(rising) {
		pwmValue+=step;
		if(pwmValue>=254) {
			rising=false;
			pwmValue=254;
		} 
	} else {
		pwmValue-=step;
		if(pwmValue<=0) {
			rising=true;
			pwmValue=0;
		}
	}
	// show current pwmValue value in window
	label.text=pwmValue.toString();
	// write pwm value to Arduino
	arduino.writeAnalogPin(ledPin,pwmValue);
	
}



