// sensor_graph_02
// graph values of analog input 0 over time
// with text info
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.display.Sprite;

var graphWidth:Number=256;
var graphHeight:Number=256;
var i:Number=0;
var analogPin:Number=0;
var vals:Array = new Array(graphWidth);
var arduino:Arduino = new Arduino("127.0.0.1", 11100);	
var graph:Sprite = new Sprite();

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setAnalogPinReporting(analogPin, Arduino.ON);
	trace("Arduino initialized.");
}

function onEnterFrame(evt:Event):void {
	//shr
	vals.shift();
	
	var val = arduino.getAnalogData(analogPin);
	label1.text = val.toString();
	label2.text = (Math.round(val/1024.0*500)/100).toString()+" V";
	//push new val
	vals.push(val/4.0);
	//draw array
	graph.graphics.clear();
	graph.graphics.beginFill(0xCCCCCC);
	graph.graphics.drawRect(0,0,graphWidth,graphHeight);
	graph.graphics.endFill();
	
	graph.graphics.lineStyle(0.5,0x000000,1.0,true,"normal",null,null,3);
	graph.graphics.moveTo(0,graphHeight-vals[0]);
	for(i=1; i<graphWidth; i++) {
		graph.graphics.lineTo(i,graphHeight-vals[i]);
	}
}

//start w/ cleared array
for(i=0; i<graphWidth; i++) {
	vals[i]=0;
}
graph.x=10;
graph.y=100;
addChild(graph);
addEventListener(Event.ENTER_FRAME,onEnterFrame);
