// sensor_graph_03
// graph values of analog inputs 0 and 1 over time
// with text info
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.display.Sprite;
import flash.text.*;

var graphWidth:Number=256;
var graphHeight:Number=256;
var i:Number=0;

var analogPin0:Number=0;
var analogPin1:Number=1;

var vals0:Array = new Array(graphWidth);
var vals1:Array = new Array(graphWidth);
var arduino:Arduino = new Arduino("127.0.0.1", 11100);	
var graph0:Sprite = new Sprite();
var graph1:Sprite = new Sprite();

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setAnalogPinReporting(analogPin0, Arduino.ON);
	arduino.setAnalogPinReporting(analogPin1, Arduino.ON);
	trace("Arduino initialized.");
}

function onEnterFrame(evt:Event):void {
	update(vals0,analogPin0,graph0,label0);
	update(vals1,analogPin1,graph1,label1);
}
	
function update(vals:Array,analogPin:Number,graph:Sprite,label:TextField) {
	//shr
	vals.shift();
	
	var val = arduino.getAnalogData(analogPin);
	label.text = val.toString()+" - "+(Math.round(val/1024.0*500)/100).toString()+" V";

	//push new val
	vals.push(val/4.0);
	//draw array
	graph.graphics.clear();
	graph.graphics.beginFill(0xCCCCCC);
	graph.graphics.drawRect(0,0,graphWidth,graphHeight);
	graph.graphics.endFill();
	
	graph.graphics.lineStyle(0.5,0x000000,1.0,true,"normal",null,null,3);
	graph.graphics.moveTo(0,graphHeight-vals[0]);
	for(i=1; i<graphWidth; i++) {
		graph.graphics.lineTo(i,graphHeight-vals[i]);
	}
}

//start w/ cleared array
for(i=0; i<graphWidth; i++) {
	vals0[i]=0;
	vals1[i]=0;
}
graph0.x=10;
graph0.y=100;
graph1.x=275;
graph1.y=100;

addChild(graph0);
addChild(graph1);
addEventListener(Event.ENTER_FRAME,onEnterFrame);
