// servo_01
// servo control example
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.ArduinoWithServo;
import net.eriksjodin.arduino.events.ArduinoEvent;
import fl.events.SliderEvent;

var servoPin:Number = 9;
var arduino:ArduinoWithServo = new ArduinoWithServo("127.0.0.1", 11100);
arduino.resetBoard();

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	//initialize the servo on pin 9, 90 degrees initial position, 
	arduino.setupServo(servoPin,90);
	//arduino.setPinMode(servoPin, ArduinoWithServo.SERVO);
	trace("Arduino initialized.");
}


slider.addEventListener(SliderEvent.THUMB_DRAG, thumbDragHandler);

function thumbDragHandler(event:SliderEvent):void {
    label.text = event.value.toString();
	arduino.writeAnalogPin(servoPin,Math.round(event.value));
}
