// switch_input_01
// show/hide movieclip based on arduino switch input
// bjoern@stanford.edu 2/12/08, revised 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;

var inputPin:Number = 2;
var arduino:Arduino = new Arduino("127.0.0.1", 11100);

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setPinMode(inputPin, Arduino.INPUT);
	arduino.enableDigitalPinReporting();
	trace("Arduino initialized.");
}

function onReceiveDigitalData(e:ArduinoEvent):void {
	if(e.pin==inputPin) {
		if (e.value==Arduino.HIGH) {
			circle.visible=false;
		} else {
			circle.visible=true;
		}

	}
}

circle.visible=false;
arduino.addEventListener(ArduinoEvent.DIGITAL_DATA, onReceiveDigitalData);

