// test_arduino
// bjoern@stanford.edu 2/12/08
// this file is included by test_arduino.fla

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;

function onSocketConnect(e:Object):void {
	statusText.appendText("Socket connected!\n");
	// request the firmware version
	arduino.requestFirmwareVersion();
}
		
// triggered when a serial socket connection has been closed
function onSocketClose(e:Object):void {
	statusText.appendText("Socket closed!\n");
}
		
// trace out data when it arrives...	
function onReceiveAnalogData(e:ArduinoEvent):void {
	statusText.appendText("Analog pin " + e.pin + " on port: " + e.port +" = " + e.value+"\n");
}
		
// trace out data when it arrives...
function onReceiveDigitalData(e:ArduinoEvent):void {
	statusText.appendText("Digital pin " + e.pin + " on port: " + e.port +" = " + e.value+"\n");
}
		
// the firmware version is requested when the Arduino class has made a socket connection.
// when we receive this event we know that the Arduino has been successfully connected.
function onReceiveFirmwareVersion(e:ArduinoEvent):void {
	statusText.appendText("Firmware version: " + e.value+"\n");
			
	// the port value of an event can be used to determine which board the event was dispatched from
	// this is one way of dealing with multiple boards, another is to add different listener methods
	statusText.appendText("Port: " + e.port+"\n");
}

var arduino:Arduino = new Arduino("127.0.0.1",11100);
arduino.addEventListener(Event.CONNECT,onSocketConnect); 
arduino.addEventListener(Event.CLOSE,onSocketClose);
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onReceiveFirmwareVersion);
arduino.addEventListener(ArduinoEvent.DIGITAL_DATA, onReceiveDigitalData);
arduino.addEventListener(ArduinoEvent.ANALOG_DATA, onReceiveAnalogData);