// vibra_control_01
// turn vibration motor connected to pin2 on Arduino on when mouse is pressed,
// off when mouse is released
// bjoern@stanford.edu 2/12/08, REVISED 12/15/08

import net.eriksjodin.arduino.Arduino;
import net.eriksjodin.arduino.events.ArduinoEvent;
import flash.events.MouseEvent;

var pin:Number = 2;
var arduino:Arduino = new Arduino("127.0.0.1", 11100);

// we first ask for the Firmware version, when it comes back, we know it's safe to initialize
arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onArduinoStartup);
arduino.requestFirmwareVersion();

// Arduino initialization
function onArduinoStartup(e:ArduinoEvent):void {
	arduino.setPinMode(pin, Arduino.OUTPUT);
	arduino.writeDigitalPin(pin, Arduino.LOW);
	trace("Arduino initialized.");
}


function onMouseClickEvent(event:MouseEvent):void {

	if(event.buttonDown) {
		arduino.writeDigitalPin(pin, Arduino.HIGH);
	}else {
		arduino.writeDigitalPin(pin, Arduino.LOW);
	}
}


stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseClickEvent);  
stage.addEventListener(MouseEvent.MOUSE_UP, onMouseClickEvent);  
