package {
	import flash.display.Sprite;
	import flash.text.TextField;
	import net.eriksjodin.arduino.Arduino;
	import net.eriksjodin.arduino.events.ArduinoEvent;
	import flash.events.Event;
	
	
	public class TestArduino extends Sprite {
		private var arduino:Arduino = new Arduino("127.0.0.1",11100);
		private var display_txt:TextField = new TextField();
		public function TestArduino() {
		
			display_txt.text = "Hello World!";
			addChild(display_txt);
			
			arduino.addEventListener(Event.CONNECT,onSocketConnect); 
			arduino.addEventListener(Event.CLOSE,onSocketClose);
			arduino.addEventListener(ArduinoEvent.FIRMWARE_VERSION, onReceiveFirmwareVersion);
			arduino.addEventListener(ArduinoEvent.DIGITAL_DATA, onReceiveDigitalData);
			arduino.addEventListener(ArduinoEvent.ANALOG_DATA, onReceiveAnalogData);
		}
		
		private function onSocketConnect(e:Object):void {
			display_txt.appendText("Socket connected!\n");
			// request the firmware version
			arduino.requestFirmwareVersion();
		}

		// triggered when a serial socket connection has been closed
		private function onSocketClose(e:Object):void {
			display_txt.appendText("Socket closed!\n");
		}

		// trace out data when it arrives...	
		private function onReceiveAnalogData(e:ArduinoEvent):void {
			display_txt.appendText("Analog pin " + e.pin + " on port: " + e.port +" = " + e.value+"\n");
		}

		// trace out data when it arrives...
		private function onReceiveDigitalData(e:ArduinoEvent):void {
			display_txt.appendText("Digital pin " + e.pin + " on port: " + e.port +" = " + e.value+"\n");
		}

		// the firmware version is requested when the Arduino class has made a socket connection.
		// when we receive this event we know that the Arduino has been successfully connected.
		private function onReceiveFirmwareVersion(e:ArduinoEvent):void {
			display_txt.appendText("Firmware version: " + e.value+"\n");

			// the port value of an event can be used to determine which board the event was dispatched from
			// this is one way of dealing with multiple boards, another is to add different listener methods
			display_txt.appendText("Port: " + e.port+"\n");
		}
		
	}
}



